//+------------------------------------------------------------------+
//|                        Goldflight's Round Number auto-trader.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property show_inputs
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define  highline "Next high round number"
#define  highlinetradetrigger "Next buy trade trigger"
#define  lowline "Next low round number"
#define  lowlinetradetrigger "Next sell trade trigger"


/*
void DisplayUserFeedback()
start()

----Trading functions----
void LookForTradingOpportunity()
bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double TP, int magic)
void GetNextRoundNumbers()
void DrawLines(string name, double price, color col, int style, int width)
void DeleteLines()
bool DoesTradeExist()

----Matt's Order Reliable library code
bool O_R_CheckForHistory(int ticket) Cheers Matt, You are a star.
void O_R_Sleep(double mean_time, double max_time)

*/




extern string     bs="----Basic stuff----";
extern double     Lot=0.01;
extern int        MagicNumber=615046;
extern string     TradeComment="Round numbers";
extern bool       CriminalIsECN=false;
extern int        TradeTriggerPips=15;
extern bool       ReverseTradeDirection=false;
extern bool       TakeFirstTrade=true;
extern string     tpsl="----Stop loss----";
extern int        StopLoss=0;
extern string     TSL="----Trailing stop loss----";
extern int        TrailingStopPips=15;
extern int        BreakEvenProfitPips=1;
extern string     trs="----Odds and ends----";
extern int        DisplayGapSize=30;
extern bool       DeleteLinesOnExit=true;
extern double     bprice=1.35511;
extern double     sprice=1.35271;
double sl = 20;
double TP = 20;




//Matt's O-R stuff
int 	            O_R_Setting_max_retries 	= 10;
double 	         O_R_Setting_sleep_time 		= 4.0; /* seconds */
double 	         O_R_Setting_sleep_max 		= 15.0; /* seconds */
   

//Round numbers
double            RoundNumberHigh, RoundNumberHighTrigger;
double            RoundNumberLow, RoundNumberLowTrigger;

//Misc stuff
string            ScreenMessage, Gap;
bool              RobotDisabled;
string            DisabledMessage;
int               Spread;


void DisplayUserFeedback()
{
   ScreenMessage = "";
   
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lot size = ", Lot, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Stop loss = ", StopLoss, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Magic number = ", MagicNumber, NL);
     double spread = MarketInfo(Symbol(), MODE_SPREAD);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Spread = ", spread, NL);
   
   ScreenMessage= StringConcatenate(ScreenMessage, NL);
   Comment(ScreenMessage);
   
   
}//void DisplayUserFeedback()


//+------------------------------------------------------------------+
//| expert Initialization function                                   |
//+------------------------------------------------------------------+

int init()
{

   int multiplier;
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   if(Digits == 6) multiplier = 100;   
   if(Digits == 7) multiplier = 1000;   
   
   TradeTriggerPips*= multiplier;
   StopLoss*= multiplier;
   
  
   BreakEvenProfitPips*= multiplier;



   Gap="";
   if (DisplayGapSize >0)
   {
      for (int cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
}
   

         
   Comment(".........Waiting for a tick");
   start();
    
  }
  
//+------------------------------------------------------------------+
//| expert Deinitialization function                                 |
//+------------------------------------------------------------------+

int deinit()
{

    
    Comment("");

}



bool DoesTradeExist()
{
   //Searches for open trades
   
   
   if (OrdersTotal() == 0) return(false); //nothing to do
   bool found = false;
   
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() ) 
      {
         found = true;
         
                 
         if (OrderProfit() > 0) TrailingStopLoss();
      }       
   }  
   
   
   return(found);
   
}//End bool DoesTradeExist()



bool SendSingleTrade(int type, string comment, double lotsize, double price, double sl, double TP, int magic)
{
   
    
   
   int slippage = 10;
   if (Digits == 3 || Digits == 5) slippage = 100;
   
   color col = Red;
   if (type == OP_BUY || type == OP_BUYSTOP) col = Green;
   
   int expiry = 0;
   //if (SendPendingTrades) expiry = TimeCurrent() + (PendingExpiryMinutes * 60);
   
   
   if (!CriminalIsECN) int ticket = OrderSend(Symbol(),type, lotsize, price, slippage, sl, TP, comment, magic, expiry, col);
   
   
   //Is a 2 stage criminal
   if (CriminalIsECN)
   {
      ticket = OrderSend(Symbol(),type, lotsize, price, slippage, 0, 0, comment, magic, expiry, col);
	   if (sl != 0)
	   {
		   if (ticket > 0)
		   bool result = OrderModify(ticket, OrderOpenPrice(), sl, TP, 0, CLR_NONE);
		   if (!result)
		   {
		       int err=GetLastError();
             Print(Symbol(), " ", type," SL  order modify failed with error(",err,"): ",ErrorDescription(err));               
		   }//if (!result)			  
	   }//if (Sl != 0)
      
      
   }//if (CriminalIsECN)
   
   //Error trapping for both
   if (ticket < 0)
   {
      string stype;
      if (type == OP_BUY) stype = "OP_BUY";
      if (type == OP_BUYSTOP) stype = "OP_BUYSTOP";
      if (type == OP_SELL) stype = "OP_SELL";
      if (type == OP_SELLSTOP) stype = "OP_SELLSTOP";
      err=GetLastError();
   
      Alert(Symbol(), " ", stype," Manual EA order send failed with error(",err,"): ",ErrorDescription(err));
      Print(Symbol(), " ", stype," Manual EA order send failed with error(",err,"): ",ErrorDescription(err));
      return(false);
   }//if (ticket < 0)  
   
   //Make sure the trade has appeared in the platform's history to avoid duplicate trades
   O_R_CheckForHistory(ticket); 
   
   //Got this far, so trade send succeeded
   return(true);
 
   
}//End bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double TP)



//START TRADE LOGIC//

void LookForTradingOpportunity()
{

   if (IsTradeContextBusy() ) return;
   
  
   RefreshRates();
   bool result;
   
   
   double MinStop = MarketInfo(Symbol(), MODE_STOPLEVEL) * Point;
   
   
   if (!ReverseTradeDirection)
   {
      //Long
      
      if(Bid >= bprice)
      //Alert (Bid, "bprice");
      {
       
      
         if (TakeFirstTrade)
         {
            //First trade with tp
            result = false;
            while (result == false)
            {
               if (StopLoss > 0) sl = NormalizeDouble(Ask - (StopLoss * Point), Digits);
               
               result = SendSingleTrade(OP_BUY, TradeComment, Lot, Ask, sl, TP, MagicNumber);
            }//while (result = false)
         }//if (TakeFirstTrade)
         
           
       }//
    


      //Short
     // if (Bid <= lo && Open[0] > lo && lo > 0)
     if(Bid <= sprice)
      {
         
      
         if (TakeFirstTrade)
         {
            //First trade with tp
            result = false;
            while (!result)
            {
               if (StopLoss > 0) sl = NormalizeDouble(Bid + (StopLoss * Point), Digits);
               result = SendSingleTrade(OP_SELL, TradeComment, Lot, Bid, sl, TP, MagicNumber);   
            }//While (!result)
         }//if (TakeFirstTrade)
         
           
      }//if (Bid <= lo && Open[1] > lo && lo > 0)
   }//if (!ReverseTradeDirection)
   
   
}//void LookForTradingOpportunity()
//END TRADE LOGIC //

//=============================================================================
//                           O_R_CheckForHistory()
//
//  This function is to work around a very annoying and dangerous bug in MT4:
//      immediately after you send a trade, the trade may NOT show up in the
//      order history, even though it exists according to ticket number.
//      As a result, EA's which count history to check for trade entries
//      may give many multiple entries, possibly blowing your account!
//
//  This function will take a ticket number and loop until
//  it is seen in the history.
//
//  RETURN VALUE:
//     TRUE if successful, FALSE otherwise
//
//
//  FEATURES:
//     * Re-trying under some error conditions, sleeping a random
//       time defined by an exponential probability distribution.
//
//     * Displays various error messages on the log for debugging.
//
//  ORIGINAL AUTHOR AND DATE:
//     Matt Kennel, 2010
//
//=============================================================================
bool O_R_CheckForHistory(int ticket)
{
   //My thanks to Matt for this code. He also has the undying gratitude of all users of my trading robots
   
   int lastTicket = OrderTicket();

   int cnt = 0;
   int err = GetLastError(); // so we clear the global variable.
   err = 0;
   bool exit_loop = false;
   bool success=false;

   while (!exit_loop) {
      /* loop through open trades */
      int total=OrdersTotal();
      for(int c = 0; c < total; c++) {
         if(OrderSelect(c,SELECT_BY_POS,MODE_TRADES) == true) {
            if (OrderTicket() == ticket) {
               success = true;
               exit_loop = true;
            }
         }
      }
      if (cnt > 3) {
         /* look through history too, as order may have opened and closed immediately */
         total=OrdersHistoryTotal();
         for(c = 0; c < total; c++) {
            if(OrderSelect(c,SELECT_BY_POS,MODE_HISTORY) == true) {
               if (OrderTicket() == ticket) {
                  success = true;
                  exit_loop = true;
               }
            }
         }
      }

      cnt = cnt+1;
      if (cnt > O_R_Setting_max_retries) {
         exit_loop = true;
      }
      if (!(success || exit_loop)) {
         Print("Did not find #"+ticket+" in history, sleeping, then doing retry #"+cnt);
         O_R_Sleep(O_R_Setting_sleep_time, O_R_Setting_sleep_max);
      }
   }
   // Select back the prior ticket num in case caller was using it.
   if (lastTicket >= 0) {
      OrderSelect(lastTicket, SELECT_BY_TICKET, MODE_TRADES);
   }
   if (!success) {
      Print("Never found #"+ticket+" in history! crap!");
   }
   return(success);
}//End bool O_R_CheckForHistory(int ticket)

//=============================================================================
//                              O_R_Sleep()
//
//  This sleeps a random amount of time defined by an exponential
//  probability distribution. The mean time, in Seconds is given
//  in 'mean_time'.
//  This returns immediately if we are backtesting
//  and does not sleep.
//
//=============================================================================
void O_R_Sleep(double mean_time, double max_time)
{
   if (IsTesting()) {
      return;   // return immediately if backtesting.
   }

   double p = (MathRand()+1) / 32768.0;
   double t = -MathLog(p)*mean_time;
   t = MathMin(t,max_time);
   int ms = t*1000;
   if (ms < 10) {
      ms=10;
   }
   Sleep(ms);
}//End void O_R_Sleep(double mean_time, double max_time)

void TrailingStopLoss()
{
      
   
   
   bool result;
   double sl=OrderStopLoss(); //Stop loss
   double BuyStop=0, SellStop=0;
   
   
   if (OrderType()==OP_BUY) 
      {
         //Breakeven
         if (OrderStopLoss() < OrderOpenPrice() ) sl = NormalizeDouble(OrderOpenPrice() + (BreakEvenProfitPips * Point), Digits);         
         {
            result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
            if (result)
            {
               Print("Trailing stop updated: ", OrderSymbol(), ": SL ", sl, ": Ask ", Ask);
            }//if (result) 
            else
            {
               int err=GetLastError();
               Print(OrderSymbol(), " Buy order modify failed with error(",err,"): ",ErrorDescription(err));
            }//else

         }//if (OrderStopLoss() < OrderOpenPrice()) sl = OrderOpenPrice() && Bid >= hiline)
         
         
         //Trail
		   if (Bid >= OrderOpenPrice() + (TrailingStopPips*Point))
		   {
		       if (OrderStopLoss() < OrderOpenPrice()) sl = OrderOpenPrice();
		       if (Bid > sl +  (TrailingStopPips*Point))
		       {
		          sl= Bid - (TrailingStopPips*Point);
		          while(IsTradeContextBusy()) Sleep(100);
		          result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
               if (result)
               {
                  Print("Trailing stop updated: ", OrderSymbol(), ": SL ", sl, ": Ask ", Ask);
               }//if (result) 
               else
               {
                  err=GetLastError();
                  Print(OrderSymbol(), " Buy order modify failed with error(",err,"): ",ErrorDescription(err));
               }//else
   
		       }//if (Bid > sl +  (TrailingStopPips*Point))
		   }//if (Bid >= OrderOpenPrice() + (TrailingStopPips*Point))
      }//if (OrderType()==OP_BUY) 

      if (OrderType()==OP_SELL) 
      {
		      
	      //Breakeven
         if (OrderStopLoss() > OrderOpenPrice() ) sl = NormalizeDouble(OrderOpenPrice() - (BreakEvenProfitPips * Point), Digits);
         {
            if (OrderStopLoss() > OrderOpenPrice()) sl = OrderOpenPrice();
		       result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
            if (result)
            {
               Print("Trailing stop updated: ", OrderSymbol(), ": SL ", sl, ": Ask ", Ask);
            }//if (result) 
            else
            {
               err=GetLastError();
               Print(OrderSymbol(), " Buy order modify failed with error(",err,"): ",ErrorDescription(err));
            }//else
         }//if (OrderStopLoss() > OrderOpenPrice() && Ask <= lowline) sl = OrderOpenPrice();         

         if (Ask <= OrderOpenPrice() - (TrailingStopPips*Point))
		   {
         	 //Trail
		       if (Ask < sl -  (TrailingStopPips*Point))
		       {
	               sl= Ask + (TrailingStopPips*Point);
  	               while(IsTradeContextBusy()) Sleep(100);
		            result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
                  if (result)
                  {
                     Print("Trailing stop updated: ", OrderSymbol(), ": SL ", sl, ": Bid ", Bid);
                  }//if (result)
                  else
                  {
                     err=GetLastError();
                     Print(OrderSymbol(), " Sell order modify failed with error(",err,"): ",ErrorDescription(err));
                  }//else
    
		       }//if (Ask < sl -  (TrailingStopPips*Point))
		   }//if (Ask <= OrderOpenPrice() - (TrailingStopPips*Point))
      }//if (OrderType()==OP_SELL) 

      
} // End of TrailingStopLoss sub


//+------------------------------------------------------------------+
//| expert Start function                                            |
//+------------------------------------------------------------------+

int start()
{
    
   
   //Check for open trade.
   if (DoesTradeExist() ) return;
   
  
    
   LookForTradingOpportunity();
       
   DisplayUserFeedback();
      
   
}//End start()


